# OmniAuth JD OAuth2

JD OAuth2 Strategy for OmniAuth 1.0.

Read JD OAuth2 docs for more details: http://jos.jd.com/doc/channel.htm?id=152

## Installing

Add to your `Gemfile`:

```ruby
gem 'omniauth-jd-oauth2'
```

Then `bundle install`.

Or install it yourself as:

    $ gem install omniauth-jd-oauth2

## Usage

`OmniAuth::Strategies::Jd` is simply a Rack middleware. Read the OmniAuth 1.0 docs for detailed instructions: https://github.com/intridea/omniauth.

Here's a quick example, adding the middleware to a Rails app in `config/initializers/omniauth.rb`:

```ruby
Rails.application.config.middleware.use OmniAuth::Builder do
  provider :jd, ENV['JD_KEY'], ENV['JD_SECRET']
end
```

## Authentication Hash

Here's an example *Authentication Hash* available in `request.env['omniauth.auth']`:

```ruby
{
       "provider" => "jd",
            "uid" => 600xx,
           "info" => {
        "nickname" => "xxx旗舰店"
    },
    "credentials" => {
                "token" => "b81cb84b-ab22-xxxx-bfdc-15831930a8cd",
        "refresh_token" => "f84fab82-4d3a-xxxx-bf72-52978d971055",
           "expires_at" => 1437913000,
              "expires" => true
    },
          "extra" => {
        "raw_info" => {
                         "brief" => "xxx旗舰店",
                 "category_main" => xxxx,
            "category_main_name" => "服装",
                     "open_time" => 139175959xxxx,
                       "shop_id" => 559xx,
                     "shop_name" => "xxx旗舰店",
                     "vender_id" => 600xx
        }
    }
}
```
*PS.* Built and tested on MRI Ruby 1.9.3

## Contributing

1. Fork it
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Added some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create new Pull Request